#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 288 "parser.y"
#include <stdio.h>
#include "spim.h"
#include "inst.h"
#include "mem.h"
#include "reg.h"
#include "sym_tbl.h"


typedef struct ll
{
  label *head;
  struct ll *tail;
} label_list;


/* Exported functions: */

imm_expr *branch_offset ();
void fix_current_label_address ();
int imm_op_to_op ();
int op_to_imm_op ();
void yyerror ();


/* Imported functions: */

imm_expr *addr_expr_imm ();
int addr_expr_reg ();
void align_data ();
imm_expr *const_imm_expr ();
imm_expr *copy_imm_expr ();
mem_addr current_data_pc ();
mem_addr current_text_pc ();
void enable_data_alignment ();
long eval_imm_expr ();
void extern_directive ();
void increment_data_pc ();
void increment_text_pc ();
imm_expr *incr_expr_offset ();
instruction * inst_decode ();
void i_type_inst ();
void j_type_inst ();
void lcomm_directive ();
label *lookup_label ();
addr_expr *make_addr_expr ();
imm_expr *make_imm_expr ();
label *make_label_global ();
void print_erroneous_line ();
label *record_label ();
void record_data_uses_symbol ();
void r_cond_type_inst ();
void r_sh_type_inst ();
instruction *r_type_inst ();
void scanner_start_line ();
void store_instruction ();
void store_byte ();
void store_double ();
void store_float ();
void store_half ();
void store_instruction ();
void store_string ();
void store_word ();
void user_kernel_data_segment ();
void user_kernel_text_segment ();
int yylex ();
int zero_imm ();


/* Local functions: */

static void clear_labels ();
static label_list *cons_label ();
static void div_inst ();
static void mult_inst ();
static void nop_inst ();
static void set_eq_inst ();
static void set_ge_inst ();
static void set_gt_inst ();
static void set_le_inst ();
static void store_word_data ();
static void trap_inst ();



char *input_file_name;

extern int y_str_length;

static int null_term;		/* Non-zero means string terminate by \0 */

static void (*store_op) ();	/* Function to store items in an EXPR_LST */

int data_dir = 0;		/* Non-zero means item in data segment */

int text_dir = 1;		/* Non-zero means item in text segment */

static label_list *this_line_labels = NULL; /* List of label for curent line */

static int noat_flag = 0;	/* Non-zero means program can use $1 */

#line 107 "y.tab.c"
#define Y_EOF 0
#define Y_NL 257
#define Y_INT 258
#define Y_ID 259
#define Y_REG 260
#define Y_FP_REG 261
#define Y_STR 262
#define Y_FP 263
#define Y_ABS_D_OP 264
#define Y_ABS_S_OP 265
#define Y_ADDIU_OP 266
#define Y_ADDI_OP 267
#define Y_ADDU_OP 268
#define Y_ADD_D_OP 269
#define Y_ADD_OP 270
#define Y_ADD_S_OP 271
#define Y_ANDI_OP 272
#define Y_AND_OP 273
#define Y_BC0F_OP 274
#define Y_BC0T_OP 275
#define Y_BC1F_OP 276
#define Y_BC1T_OP 277
#define Y_BC2F_OP 278
#define Y_BC2T_OP 279
#define Y_BC3F_OP 280
#define Y_BC3T_OP 281
#define Y_BEQ_OP 282
#define Y_BGEZAL_OP 283
#define Y_BGEZ_OP 284
#define Y_BGTZ_OP 285
#define Y_BLEZ_OP 286
#define Y_BLTZAL_OP 287
#define Y_BLTZ_OP 288
#define Y_BNE_OP 289
#define Y_BREAK_OP 290
#define Y_CFC0_OP 291
#define Y_CFC1_OP 292
#define Y_CFC2_OP 293
#define Y_CFC3_OP 294
#define Y_COP0_OP 295
#define Y_COP1_OP 296
#define Y_COP2_OP 297
#define Y_COP3_OP 298
#define Y_CTC0_OP 299
#define Y_CTC1_OP 300
#define Y_CTC2_OP 301
#define Y_CTC3_OP 302
#define Y_CVT_D_S_OP 303
#define Y_CVT_D_W_OP 304
#define Y_CVT_S_D_OP 305
#define Y_CVT_S_W_OP 306
#define Y_CVT_W_D_OP 307
#define Y_CVT_W_S_OP 308
#define Y_C_EQ_D_OP 309
#define Y_C_EQ_S_OP 310
#define Y_C_F_D_OP 311
#define Y_C_F_S_OP 312
#define Y_C_LE_D_OP 313
#define Y_C_LE_S_OP 314
#define Y_C_LT_D_OP 315
#define Y_C_LT_S_OP 316
#define Y_C_NGE_D_OP 317
#define Y_C_NGE_S_OP 318
#define Y_C_NGLE_D_OP 319
#define Y_C_NGLE_S_OP 320
#define Y_C_NGL_D_OP 321
#define Y_C_NGL_S_OP 322
#define Y_C_NGT_D_OP 323
#define Y_C_NGT_S_OP 324
#define Y_C_OLE_D_OP 325
#define Y_C_OLE_S_OP 326
#define Y_C_SEQ_D_OP 327
#define Y_C_SEQ_S_OP 328
#define Y_C_SF_D_OP 329
#define Y_C_SF_S_OP 330
#define Y_C_UEQ_D_OP 331
#define Y_C_UEQ_S_OP 332
#define Y_C_ULE_D_OP 333
#define Y_C_ULE_S_OP 334
#define Y_C_UN_D_OP 335
#define Y_C_UN_S_OP 336
#define Y_DIVU_OP 337
#define Y_DIV_D_OP 338
#define Y_DIV_OP 339
#define Y_DIV_S_OP 340
#define Y_JALR_OP 341
#define Y_JAL_OP 342
#define Y_JR_OP 343
#define Y_J_OP 344
#define Y_LBU_OP 345
#define Y_LB_OP 346
#define Y_LHU_OP 347
#define Y_LH_OP 348
#define Y_LUI_OP 349
#define Y_LWC0_OP 350
#define Y_LWC1_OP 351
#define Y_LWC2_OP 352
#define Y_LWC3_OP 353
#define Y_LWL_OP 354
#define Y_LWR_OP 355
#define Y_LW_OP 356
#define Y_MFC0_OP 357
#define Y_MFC1_OP 358
#define Y_MFC2_OP 359
#define Y_MFC3_OP 360
#define Y_MFHI_OP 361
#define Y_MFLO_OP 362
#define Y_MOV_D_OP 363
#define Y_MOV_S_OP 364
#define Y_MTC0_OP 365
#define Y_MTC1_OP 366
#define Y_MTC2_OP 367
#define Y_MTC3_OP 368
#define Y_MTHI_OP 369
#define Y_MTLO_OP 370
#define Y_MULTU_OP 371
#define Y_MULT_OP 372
#define Y_MUL_D_OP 373
#define Y_MUL_S_OP 374
#define Y_NEG_D_OP 375
#define Y_NEG_S_OP 376
#define Y_NOR_OP 377
#define Y_ORI_OP 378
#define Y_OR_OP 379
#define Y_RFE_OP 380
#define Y_SB_OP 381
#define Y_SH_OP 382
#define Y_SLLV_OP 383
#define Y_SLL_OP 384
#define Y_SLTIU_OP 385
#define Y_SLTI_OP 386
#define Y_SLTU_OP 387
#define Y_SLT_OP 388
#define Y_SRAV_OP 389
#define Y_SRA_OP 390
#define Y_SRLV_OP 391
#define Y_SRL_OP 392
#define Y_SUBU_OP 393
#define Y_SUB_D_OP 394
#define Y_SUB_OP 395
#define Y_SUB_S_OP 396
#define Y_SWC0_OP 397
#define Y_SWC1_OP 398
#define Y_SWC2_OP 399
#define Y_SWC3_OP 400
#define Y_SWL_OP 401
#define Y_SWR_OP 402
#define Y_SW_OP 403
#define Y_SYSCALL_OP 404
#define Y_TLBP_OP 405
#define Y_TLBR_OP 406
#define Y_TLBWI_OP 407
#define Y_TLBWR_OP 408
#define Y_XORI_OP 409
#define Y_XOR_OP 410
#define Y_ABS_POP 411
#define Y_BAL_POP 412
#define Y_BEQZ_POP 413
#define Y_BGEU_POP 414
#define Y_BGE_POP 415
#define Y_BGTU_POP 416
#define Y_BGT_POP 417
#define Y_BLEU_POP 418
#define Y_BLE_POP 419
#define Y_BLTU_POP 420
#define Y_BLT_POP 421
#define Y_BNEZ_POP 422
#define Y_B_POP 423
#define Y_LA_POP 424
#define Y_LD_POP 425
#define Y_LI_POP 426
#define Y_LI_D_POP 427
#define Y_LI_S_POP 428
#define Y_L_D_POP 429
#define Y_L_S_POP 430
#define Y_MFC1_D_POP 431
#define Y_MTC1_D_POP 432
#define Y_MOVE_POP 433
#define Y_MULOU_POP 434
#define Y_MULO_POP 435
#define Y_MUL_POP 436
#define Y_NEGU_POP 437
#define Y_NEG_POP 438
#define Y_NOP_POP 439
#define Y_NOT_POP 440
#define Y_REMU_POP 441
#define Y_REM_POP 442
#define Y_ROL_POP 443
#define Y_ROR_POP 444
#define Y_SD_POP 445
#define Y_SEQ_POP 446
#define Y_SGEU_POP 447
#define Y_SGE_POP 448
#define Y_SGTU_POP 449
#define Y_SGT_POP 450
#define Y_SLEU_POP 451
#define Y_SLE_POP 452
#define Y_SNE_POP 453
#define Y_S_D_POP 454
#define Y_S_S_POP 455
#define Y_ULHU_POP 456
#define Y_ULH_POP 457
#define Y_ULW_POP 458
#define Y_USH_POP 459
#define Y_USW_POP 460
#define Y_ALIAS_DIR 461
#define Y_ALIGN_DIR 462
#define Y_ASCII_DIR 463
#define Y_ASCIIZ_DIR 464
#define Y_ASM0_DIR 465
#define Y_BGNB_DIR 466
#define Y_BYTE_DIR 467
#define Y_COMM_DIR 468
#define Y_DATA_DIR 469
#define Y_DOUBLE_DIR 470
#define Y_ENDB_DIR 471
#define Y_ENDR_DIR 472
#define Y_END_DIR 473
#define Y_ENT_DIR 474
#define Y_ERR_DIR 475
#define Y_EXTERN_DIR 476
#define Y_FILE_DIR 477
#define Y_FLOAT_DIR 478
#define Y_FMASK_DIR 479
#define Y_FRAME_DIR 480
#define Y_GLOBAL_DIR 481
#define Y_HALF_DIR 482
#define Y_K_TEXT_DIR 483
#define Y_K_DATA_DIR 484
#define Y_LABEL_DIR 485
#define Y_LCOMM_DIR 486
#define Y_LIVEREG_DIR 487
#define Y_LOC_DIR 488
#define Y_MASK_DIR 489
#define Y_NOALIAS_DIR 490
#define Y_OPTIONS_DIR 491
#define Y_RDATA_DIR 492
#define Y_REPEAT_DIR 493
#define Y_SDATA_DIR 494
#define Y_SET_DIR 495
#define Y_SPACE_DIR 496
#define Y_STRUCT_DIR 497
#define Y_TEXT_DIR 498
#define Y_VERSTAMP_DIR 499
#define Y_VREG_DIR 500
#define Y_WORD_DIR 501
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    2,    0,    1,    1,    3,    3,    3,    3,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    6,    6,
    6,    6,    6,    6,    6,    6,    9,    9,    9,   11,
   14,   14,   15,   15,   15,   16,   16,   16,   16,   16,
   16,   18,   18,   18,   19,   19,   19,   21,   21,   23,
   23,   23,   23,   23,   23,   23,   25,   25,   25,   26,
   26,   26,   26,   26,   26,   26,   27,   27,   27,   28,
   28,   28,   29,   29,   29,   29,   30,   30,   30,   32,
   32,   33,   33,   34,   34,   35,   35,   31,   31,   36,
   36,   36,   36,   36,   36,   36,   36,   38,   38,   38,
   38,   38,   38,   39,   39,   40,   40,   41,   41,   42,
   42,   43,   43,   44,   44,   45,   45,   45,   45,   47,
   47,   48,   48,   49,   49,   51,   51,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   53,   53,   53,
   53,   53,   53,   53,   53,   54,   54,   55,   55,   55,
   55,   55,   55,   55,   55,   57,   57,   57,   57,   57,
   57,   58,   58,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
   59,    5,    5,   62,    5,   63,    5,    5,    5,   65,
    5,    5,    5,    5,   67,    5,    5,    5,    5,    5,
    5,    5,    5,    5,   69,    5,    5,    5,    5,   71,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,   72,    5,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
   12,   12,   12,   12,   73,    7,   22,   24,   46,   50,
   17,   70,   13,   20,   56,   74,   10,   10,   37,   61,
   61,   60,   60,   64,   64,   64,   66,   66,   68,   68,
};
short yylen[] = {                                         2,
    0,    4,    2,    0,    2,    2,    1,    1,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    1,    2,    1,    3,    3,    3,    3,
    3,    4,    4,    3,    4,    4,    3,    4,    3,    4,
    4,    4,    3,    3,    4,    4,    4,    4,    3,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    2,    3,    3,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    2,    2,    3,    2,    3,    2,
    2,    3,    3,    3,    4,    3,    3,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    2,    0,    3,    0,    3,    1,    2,    0,
    3,    3,    1,    1,    0,    3,    2,    2,    1,    2,
    3,    3,    1,    3,    0,    3,    3,    4,    2,    0,
    3,    2,    3,    3,    3,    3,    3,    2,    2,    1,
    1,    2,    2,    2,    1,    1,    3,    4,    0,    3,
    3,    1,    4,    1,    4,    3,    3,    3,    6,    6,
    1,    1,    3,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    2,    1,    3,    2,    1,    1,    0,
};
short yydefred[] = {                                      1,
    0,    0,    0,    0,    3,    8,    7,  217,  216,  131,
  130,  121,  219,  120,  218,  132,  122,  164,  160,  165,
  161,  166,  162,  167,  163,  176,  169,  168,  170,  171,
  173,  172,  177,    0,  208,  209,  210,  211,  212,  213,
  214,  215,  226,  227,  228,  229,  230,  231,  250,  236,
  248,  234,  260,  246,  258,  244,  259,  245,  255,  241,
  257,  243,  261,  247,  252,  238,  256,  242,  254,  240,
  251,  237,  253,  239,  249,  235,  144,  221,  143,  220,
  189,  188,  187,  186,   90,   89,   92,   91,  100,   97,
  103,   98,   99,   94,   95,   93,  198,  199,  201,  202,
  194,  195,  193,  192,  203,  204,  206,  207,  196,  197,
  159,  158,  223,  222,  233,  232,  140,  133,  124,  118,
  106,  107,  127,  137,  136,  135,  126,  125,  128,  138,
  129,  139,  142,  225,  141,  224,  112,  115,  113,  114,
  109,  110,  108,  119,  134,  123,    0,  191,  174,  181,
  180,  179,  178,  185,  184,  183,  182,  175,  190,    0,
   96,    0,    0,    0,  105,  104,  200,  205,    0,  149,
  148,  147,    0,    0,   26,    0,  146,  145,    0,    0,
  111,  156,  155,  154,  153,  152,  151,  150,  157,  117,
  116,  102,  101,    0,    0,    0,    0,    0,  264,  266,
  268,    0,  270,    0,  273,  275,    0,  279,    0,    0,
  283,    0,    0,  285,    0,    0,    0,  290,  306,  274,
    0,    0,    0,    0,    0,    0,    0,  300,    0,  301,
    0,    0,    0,  305,    0,    0,  309,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   24,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   25,  332,    0,  326,    0,    0,  336,    0,  333,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  331,
    0,    0,  342,  343,  263,    0,    0,  269,    0,    0,
    0,  278,  349,  277,    0,    0,    0,    0,    0,    0,
  289,    0,  292,    0,    0,    0,    0,    0,  298,  299,
  302,  303,  304,    0,    0,    0,    2,    5,    6,    0,
  337,  338,    0,    0,    0,    0,    0,    0,    0,  334,
    0,    0,    0,    0,    0,    0,    0,    0,  327,    0,
    0,    0,    0,  339,   62,    0,    0,    0,    0,    0,
    0,    0,   76,   75,    0,    0,   78,    0,   80,  330,
   81,    0,    0,    0,    0,    0,    0,    0,   27,  325,
    0,    0,   12,    0,    0,   13,  321,   14,   15,   31,
   29,   28,   30,    0,    0,   16,   22,   21,  262,  341,
    0,    0,    0,    0,  272,  348,    0,  281,  282,  284,
    0,  287,    0,    0,  293,  294,  295,  296,  297,  307,
    0,    0,    9,   10,   11,   17,   18,   19,   20,   23,
   34,    0,   37,    0,   39,    0,    0,   43,    0,    0,
    0,   49,  328,    0,    0,    0,    0,   63,   64,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   77,
   79,   82,   83,   84,    0,   86,  335,   87,   88,    0,
    0,    0,    0,    0,    0,    0,    0,   53,   51,   52,
   50,  340,    0,  344,  347,  288,  308,   33,   32,   36,
   35,   38,   40,   42,   41,   46,   45,   48,   47,   55,
   54,   57,   56,   59,   58,   61,   60,   66,   65,   68,
   67,   70,   69,   72,   71,   74,   73,   85,    0,    0,
    0,  311,    0,  317,  323,  324,  346,  315,    0,    0,
  313,    0,    0,  319,  320,
};
short yydgoto[] = {                                       1,
    4,    2,  238,  239,  240,  241,  284,  393,  242,  343,
  243,  396,  289,  244,  245,  246,  299,  247,  248,  349,
  249,  358,  250,  452,  251,  252,  253,  254,  255,  256,
  257,  258,  259,  260,  261,  262,  365,  263,  264,  265,
  266,  267,  268,  269,  270,  375,  271,  272,  273,  379,
  274,  275,  276,  277,  278,  476,  279,  280,  281,  413,
  411,  306,  307,  414,  309,  417,  311,  314,  318,  359,
  322,  336,  397,  290,
};
short yysindex[] = {                                      0,
    0, -247,  -35,    1,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -218,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -206,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -206,
    0, -206, -217, -217,    0,    0,    0,    0, -206,    0,
    0,    0, -206, -206,    0, -206,    0,    0, -206, -206,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -206, -206, -206, -200, -226,    0,    0,
    0, -196,    0, -186,    0,    0, -184,    0, -181, -179,
    0, -178, -176,    0, -175, -206, -171,    0,    0,    0,
 -170, -169, -174, -167, -159, -160, -157,    0, -226,    0,
 -151, -226, -226,    0, -149, -206,    0, -144, -143, -142,
 -206, -215, -206, -206, -217, -206, -215, -217,    0, -206,
 -206, -206, -206, -206, -206, -206, -206, -206, -206, -206,
 -206, -135, -206, -206, -206, -206, -206, -206, -206, -212,
 -135, -215, -206, -206, -206, -215, -217, -217, -217, -217,
 -217,    0,    0, -206,    0,  -38, -189,    0, -147,    0,
 -146, -206, -206, -206, -206, -206, -206,  -38,  -38,    0,
  -38, -133,    0,    0,    0, -129, -129,    0, -226, -226,
 -118,    0,    0,    0, -124, -226, -116, -118, -111, -108,
    0, -226,    0, -226, -107, -106, -105, -104,    0,    0,
    0,    0,    0, -103, -101, -226,    0,    0,    0,  -38,
    0,    0,  -38, -189,  -38,  -38,  -38,  -38,  -38,    0,
 -233, -233, -233, -206, -233, -206, -206, -206,    0, -206,
 -206, -206, -206,    0,    0, -135, -135, -233, -233, -233,
 -233, -233,    0,    0, -206,    0,    0, -215,    0,    0,
    0, -215, -215, -217, -217, -217, -217, -217,    0,    0,
  -25, -206,    0,  -29,   -6,    0,    0,    0,    0,    0,
    0,    0,    0, -233, -233,    0,    0,    0,    0,    0,
 -102, -102,   96, -226,    0,    0, -100,    0,    0,    0,
 -100,    0, -206, -226,    0,    0,    0,    0,    0,    0,
  -99, -226,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -233,    0, -233,    0, -189,  -97,    0, -233, -233,
 -233,    0,    0, -233, -233, -233, -233,    0,    0, -135,
 -135, -135, -135, -135, -135, -135, -135, -135, -135,    0,
    0,    0,    0,    0, -217,    0,    0,    0,    0, -206,
  -96,  -96,  117, -206,  -95,  -96,  -96,    0,    0,    0,
    0,    0,  -93,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  126,  129,
  131,    0,  135,    0,    0,    0,    0,    0, -206, -206,
    0,  136,  141,    0,    0,
};
short yyrindex[] = {                                      0,
    0,  246,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -85,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -74,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -236,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -73,    0,    0,  -72, -216,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -71,  -70, -229,  -69,    0,    0,  -68,    0,    0,    0,
  -67,    0,    0,  -66,    0,    0,    0,    0,    0,    0,
    0,  -65,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -64,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -63,
  -62,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,  758, -242,    0, -234,
    0, -276, -158,    0,    0,    0, -191,    0,    0, -274,
    0,  535,    0, -319,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  482,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -203,
    0,    0,    0,    0,    0, -378,    0,    0,    0, -198,
 -110,    0,    0, -314,    0, -122,    0,    0,    0,  601,
    0,    0, -282, -245,
};
#define YYTABLESIZE 1141
short yytable[] = {                                     305,
    6,  392,  350,  394,  301,  291,  388,  424,  478,  479,
  484,    3,  348,  485,  480,  394,  394,  481,  394,  482,
  327,  432,    5,  329,  390,  395,  283,  345,  345,  345,
  330,  303,  304,  332,  333,  350,  486,  378,  487,  282,
  322,  383,  322,  288,  341,  342,  364,  283,  461,  463,
  465,  467,  469,  283,  347,  406,  407,  394,  408,  302,
  394,  308,  394,  394,  394,  394,  394,  435,  390,  395,
  381,  382,  310,  312,  441,  443,  445,  313,  448,  315,
  316,  317,  319,  325,  489,  491,  346,  321,  323,  324,
  326,  460,  462,  464,  466,  468,  528,  433,  327,  328,
  434,  329,  436,  437,  438,  439,  440,  331,  334,  474,
  475,  415,  337,  338,  339,  398,  399,  419,  384,  385,
  386,  387,  499,  364,  501,  425,  409,  488,  490,  505,
  507,  509,  410,  418,  511,  513,  515,  517,  350,  350,
  477,  477,  477,  471,  416,  420,  422,  472,  473,  423,
  426,  427,  428,  493,  430,  429,  431,  532,  497,  492,
  503,  390,  495,  534,  537,  498,  538,  500,  539,  502,
  540,  350,  504,  506,  508,  541,  544,  510,  512,  514,
  516,  545,  280,  314,  312,  265,  267,  271,  276,  286,
  291,  310,   44,  316,  318,  421,  412,    0,  530,  531,
    0,    0,    0,  535,  536,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  494,    0,    0,    0,  390,
  391,    0,    0,    0,    0,  494,    0,    0,    0,  477,
    0,    0,    0,  494,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    4,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    7,    0,    0,
    0,    0,    0,    0,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,    0,    0,    0,    0,   39,
   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
  110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
  120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
  130,  131,  132,  133,  134,  135,  136,  137,  138,  139,
  140,  141,  142,  143,  144,    0,    0,    0,    0,  145,
  146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
  156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
  176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
  206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,    4,    0,    0,    0,    0,    0,    0,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    0,    0,    0,    0,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    0,    0,    0,    0,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    4,    4,    4,    4,  285,    0,    0,
    0,  374,  377,    0,    0,    0,    0,    0,    0,    0,
  285,    0,  285,    0,    0,    0,    0,    0,    0,  285,
    0,    0,    0,  285,  285,    0,  285,    0,    0,  285,
  285,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  285,  300,  300,  366,  367,  368,
  369,  370,  371,  372,  373,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  320,    0,  389,    0,
    0,    0,    0,    0,    0,    0,  400,  401,  402,  403,
  404,  405,    0,    0,    0,    0,  335,    0,    0,    0,
    0,  285,    0,  285,  285,    0,  300,  458,  459,    0,
  285,  285,  285,  285,  285,  285,  285,    0,  285,  285,
  285,  285,    0,    0,    0,    0,    0,    0,    0,    0,
  376,    0,    0,  380,  380,  380,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  442,  444,  446,  447,  449,
  450,  451,    0,    0,  454,  455,  456,  457,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  470,
    0,    0,    0,    0,    0,    0,    0,  286,    0,  287,
    0,    0,    0,    0,    0,    0,  292,    0,    0,    0,
  293,  294,    0,  295,    0,    0,  296,  297,    0,    0,
    0,  518,  519,  520,  521,  522,  523,  524,  525,  526,
  527,  298,    0,    0,    0,    0,    0,    0,  453,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  453,  453,
  453,  453,  453,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  483,    0,    0,    0,    0,    0,  340,    0,
  344,  345,    0,    0,  453,  453,    0,  351,  352,  353,
  354,  355,  356,  357,    0,  360,  361,  362,  363,    0,
    0,    0,    0,  496,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  453,    0,  453,    0,    0,    0,    0,  453,
  453,  453,    0,    0,  453,  453,  453,  453,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  529,    0,    0,    0,  533,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  542,
  543,
};
short yycheck[] = {                                     198,
    0,   40,  248,  286,  196,  164,  281,  322,  387,  388,
   40,  259,  247,   43,   40,  298,  299,   43,  301,   45,
  257,  336,   58,  260,  258,  259,  260,  257,  258,  259,
  229,  258,  259,  232,  233,  281,   43,  272,   45,  258,
  257,  276,  259,  261,  260,  261,  259,  260,  368,  369,
  370,  371,  372,  260,  246,  298,  299,  340,  301,  260,
  343,  258,  345,  346,  347,  348,  349,  344,  258,  259,
  274,  275,  259,  258,  351,  352,  353,  259,  355,  259,
  259,  258,  258,  258,  404,  405,  245,  259,  259,  259,
  258,  368,  369,  370,  371,  372,  475,  340,  258,  260,
  343,  259,  345,  346,  347,  348,  349,  259,  258,  384,
  385,  310,  257,  257,  257,  263,  263,  316,  277,  278,
  279,  280,  442,  259,  444,  324,  260,  404,  405,  449,
  450,  451,  262,  258,  454,  455,  456,  457,  384,  385,
  386,  387,  388,  378,  263,  262,  258,  382,  383,  258,
  258,  258,  258,   58,  258,  260,  258,   41,  258,  262,
  258,  258,  263,  259,  258,  442,   41,  444,   40,  446,
   40,  257,  449,  450,  451,   41,   41,  454,  455,  456,
  457,   41,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,  318,  307,   -1,  481,  482,
   -1,   -1,   -1,  486,  487,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  414,   -1,   -1,   -1,  258,
  259,   -1,   -1,   -1,   -1,  424,   -1,   -1,   -1,  475,
   -1,   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,
   -1,   -1,   -1,   -1,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,   -1,   -1,   -1,   -1,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,   -1,   -1,   -1,   -1,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,  428,  429,
  430,  431,  432,  433,  434,  435,  436,  437,  438,  439,
  440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
  450,  451,  452,  453,  454,  455,  456,  457,  458,  459,
  460,  461,  462,  463,  464,  465,  466,  467,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,  481,  482,  483,  484,  485,  486,  487,  488,  489,
  490,  491,  492,  493,  494,  495,  496,  497,  498,  499,
  500,  501,  257,   -1,   -1,   -1,   -1,   -1,   -1,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
   -1,   -1,   -1,   -1,  299,  300,  301,  302,  303,  304,
  305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
  325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
   -1,   -1,   -1,   -1,  409,  410,  411,  412,  413,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
  435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
  445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
  455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
  465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,  481,  482,  483,  484,
  485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
  495,  496,  497,  498,  499,  500,  501,  147,   -1,   -1,
   -1,  270,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  160,   -1,  162,   -1,   -1,   -1,   -1,   -1,   -1,  169,
   -1,   -1,   -1,  173,  174,   -1,  176,   -1,   -1,  179,
  180,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  194,  195,  196,  263,  264,  265,
  266,  267,  268,  269,  270,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  216,   -1,  284,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  292,  293,  294,  295,
  296,  297,   -1,   -1,   -1,   -1,  236,   -1,   -1,   -1,
   -1,  241,   -1,  243,  244,   -1,  246,  366,  367,   -1,
  250,  251,  252,  253,  254,  255,  256,   -1,  258,  259,
  260,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  270,   -1,   -1,  273,  274,  275,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,  352,  353,  354,  355,
  356,  357,   -1,   -1,  360,  361,  362,  363,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  375,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  160,   -1,  162,
   -1,   -1,   -1,   -1,   -1,   -1,  169,   -1,   -1,   -1,
  173,  174,   -1,  176,   -1,   -1,  179,  180,   -1,   -1,
   -1,  460,  461,  462,  463,  464,  465,  466,  467,  468,
  469,  194,   -1,   -1,   -1,   -1,   -1,   -1,  358,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,
  370,  371,  372,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,  241,   -1,
  243,  244,   -1,   -1,  404,  405,   -1,  250,  251,  252,
  253,  254,  255,  256,   -1,  258,  259,  260,  261,   -1,
   -1,   -1,   -1,  423,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  442,   -1,  444,   -1,   -1,   -1,   -1,  449,
  450,  451,   -1,   -1,  454,  455,  456,  457,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  480,   -1,   -1,   -1,  484,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  539,
  540,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 501
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,"'+'",0,"'-'",0,0,0,0,0,0,0,0,0,0,0,0,"':'",0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"Y_NL",
"Y_INT","Y_ID","Y_REG","Y_FP_REG","Y_STR","Y_FP","Y_ABS_D_OP","Y_ABS_S_OP",
"Y_ADDIU_OP","Y_ADDI_OP","Y_ADDU_OP","Y_ADD_D_OP","Y_ADD_OP","Y_ADD_S_OP",
"Y_ANDI_OP","Y_AND_OP","Y_BC0F_OP","Y_BC0T_OP","Y_BC1F_OP","Y_BC1T_OP",
"Y_BC2F_OP","Y_BC2T_OP","Y_BC3F_OP","Y_BC3T_OP","Y_BEQ_OP","Y_BGEZAL_OP",
"Y_BGEZ_OP","Y_BGTZ_OP","Y_BLEZ_OP","Y_BLTZAL_OP","Y_BLTZ_OP","Y_BNE_OP",
"Y_BREAK_OP","Y_CFC0_OP","Y_CFC1_OP","Y_CFC2_OP","Y_CFC3_OP","Y_COP0_OP",
"Y_COP1_OP","Y_COP2_OP","Y_COP3_OP","Y_CTC0_OP","Y_CTC1_OP","Y_CTC2_OP",
"Y_CTC3_OP","Y_CVT_D_S_OP","Y_CVT_D_W_OP","Y_CVT_S_D_OP","Y_CVT_S_W_OP",
"Y_CVT_W_D_OP","Y_CVT_W_S_OP","Y_C_EQ_D_OP","Y_C_EQ_S_OP","Y_C_F_D_OP",
"Y_C_F_S_OP","Y_C_LE_D_OP","Y_C_LE_S_OP","Y_C_LT_D_OP","Y_C_LT_S_OP",
"Y_C_NGE_D_OP","Y_C_NGE_S_OP","Y_C_NGLE_D_OP","Y_C_NGLE_S_OP","Y_C_NGL_D_OP",
"Y_C_NGL_S_OP","Y_C_NGT_D_OP","Y_C_NGT_S_OP","Y_C_OLE_D_OP","Y_C_OLE_S_OP",
"Y_C_SEQ_D_OP","Y_C_SEQ_S_OP","Y_C_SF_D_OP","Y_C_SF_S_OP","Y_C_UEQ_D_OP",
"Y_C_UEQ_S_OP","Y_C_ULE_D_OP","Y_C_ULE_S_OP","Y_C_UN_D_OP","Y_C_UN_S_OP",
"Y_DIVU_OP","Y_DIV_D_OP","Y_DIV_OP","Y_DIV_S_OP","Y_JALR_OP","Y_JAL_OP",
"Y_JR_OP","Y_J_OP","Y_LBU_OP","Y_LB_OP","Y_LHU_OP","Y_LH_OP","Y_LUI_OP",
"Y_LWC0_OP","Y_LWC1_OP","Y_LWC2_OP","Y_LWC3_OP","Y_LWL_OP","Y_LWR_OP","Y_LW_OP",
"Y_MFC0_OP","Y_MFC1_OP","Y_MFC2_OP","Y_MFC3_OP","Y_MFHI_OP","Y_MFLO_OP",
"Y_MOV_D_OP","Y_MOV_S_OP","Y_MTC0_OP","Y_MTC1_OP","Y_MTC2_OP","Y_MTC3_OP",
"Y_MTHI_OP","Y_MTLO_OP","Y_MULTU_OP","Y_MULT_OP","Y_MUL_D_OP","Y_MUL_S_OP",
"Y_NEG_D_OP","Y_NEG_S_OP","Y_NOR_OP","Y_ORI_OP","Y_OR_OP","Y_RFE_OP","Y_SB_OP",
"Y_SH_OP","Y_SLLV_OP","Y_SLL_OP","Y_SLTIU_OP","Y_SLTI_OP","Y_SLTU_OP",
"Y_SLT_OP","Y_SRAV_OP","Y_SRA_OP","Y_SRLV_OP","Y_SRL_OP","Y_SUBU_OP",
"Y_SUB_D_OP","Y_SUB_OP","Y_SUB_S_OP","Y_SWC0_OP","Y_SWC1_OP","Y_SWC2_OP",
"Y_SWC3_OP","Y_SWL_OP","Y_SWR_OP","Y_SW_OP","Y_SYSCALL_OP","Y_TLBP_OP",
"Y_TLBR_OP","Y_TLBWI_OP","Y_TLBWR_OP","Y_XORI_OP","Y_XOR_OP","Y_ABS_POP",
"Y_BAL_POP","Y_BEQZ_POP","Y_BGEU_POP","Y_BGE_POP","Y_BGTU_POP","Y_BGT_POP",
"Y_BLEU_POP","Y_BLE_POP","Y_BLTU_POP","Y_BLT_POP","Y_BNEZ_POP","Y_B_POP",
"Y_LA_POP","Y_LD_POP","Y_LI_POP","Y_LI_D_POP","Y_LI_S_POP","Y_L_D_POP",
"Y_L_S_POP","Y_MFC1_D_POP","Y_MTC1_D_POP","Y_MOVE_POP","Y_MULOU_POP",
"Y_MULO_POP","Y_MUL_POP","Y_NEGU_POP","Y_NEG_POP","Y_NOP_POP","Y_NOT_POP",
"Y_REMU_POP","Y_REM_POP","Y_ROL_POP","Y_ROR_POP","Y_SD_POP","Y_SEQ_POP",
"Y_SGEU_POP","Y_SGE_POP","Y_SGTU_POP","Y_SGT_POP","Y_SLEU_POP","Y_SLE_POP",
"Y_SNE_POP","Y_S_D_POP","Y_S_S_POP","Y_ULHU_POP","Y_ULH_POP","Y_ULW_POP",
"Y_USH_POP","Y_USW_POP","Y_ALIAS_DIR","Y_ALIGN_DIR","Y_ASCII_DIR",
"Y_ASCIIZ_DIR","Y_ASM0_DIR","Y_BGNB_DIR","Y_BYTE_DIR","Y_COMM_DIR","Y_DATA_DIR",
"Y_DOUBLE_DIR","Y_ENDB_DIR","Y_ENDR_DIR","Y_END_DIR","Y_ENT_DIR","Y_ERR_DIR",
"Y_EXTERN_DIR","Y_FILE_DIR","Y_FLOAT_DIR","Y_FMASK_DIR","Y_FRAME_DIR",
"Y_GLOBAL_DIR","Y_HALF_DIR","Y_K_TEXT_DIR","Y_K_DATA_DIR","Y_LABEL_DIR",
"Y_LCOMM_DIR","Y_LIVEREG_DIR","Y_LOC_DIR","Y_MASK_DIR","Y_NOALIAS_DIR",
"Y_OPTIONS_DIR","Y_RDATA_DIR","Y_REPEAT_DIR","Y_SDATA_DIR","Y_SET_DIR",
"Y_SPACE_DIR","Y_STRUCT_DIR","Y_TEXT_DIR","Y_VERSTAMP_DIR","Y_VREG_DIR",
"Y_WORD_DIR",
};
char *yyrule[] = {
"$accept : LINE",
"$$1 :",
"LINE : $$1 OPT_LBL CMD Y_NL",
"OPT_LBL : Y_ID ':'",
"OPT_LBL :",
"CMD : ASM_CODE Y_NL",
"CMD : ASM_DIRECTIVE Y_NL",
"CMD : Y_NL",
"CMD : Y_EOF",
"ASM_CODE : LOAD_OP DEST_REG ADDRESS",
"ASM_CODE : LOAD_COP COP_REG ADDRESS",
"ASM_CODE : LOAD_IMM_OP DEST_REG IMM",
"ASM_CODE : Y_LA_POP DEST_REG ADDRESS",
"ASM_CODE : Y_LI_POP DEST_REG IMM",
"ASM_CODE : Y_LI_D_POP F_DEST Y_FP",
"ASM_CODE : Y_LI_S_POP F_DEST Y_FP",
"ASM_CODE : Y_ULW_POP DEST_REG ADDRESS",
"ASM_CODE : ULOADH_POP DEST_REG ADDRESS",
"ASM_CODE : LOADF_OP F_DEST ADDRESS",
"ASM_CODE : STORE_OP SOURCE ADDRESS",
"ASM_CODE : STORE_COP COP_REG ADDRESS",
"ASM_CODE : Y_USW_POP SOURCE ADDRESS",
"ASM_CODE : Y_USH_POP SOURCE ADDRESS",
"ASM_CODE : STOREF_OP F_SRC1 ADDRESS",
"ASM_CODE : SYS_OP",
"ASM_CODE : Y_BREAK_OP Y_INT",
"ASM_CODE : Y_NOP_POP",
"ASM_CODE : Y_ABS_POP DEST_REG SRC1",
"ASM_CODE : Y_NEG_POP DEST_REG SRC1",
"ASM_CODE : Y_NEGU_POP DEST_REG SRC1",
"ASM_CODE : Y_NOT_POP DEST_REG SRC1",
"ASM_CODE : Y_MOVE_POP DEST_REG SRC1",
"ASM_CODE : BINARY_OP_I DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OP_I DEST_REG SRC1 IMM",
"ASM_CODE : BINARY_OP_I DEST_REG IMM",
"ASM_CODE : BINARY_OPR_I DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OPR_I DEST_REG SRC1 IMM",
"ASM_CODE : BINARY_OPR_I DEST_REG IMM",
"ASM_CODE : BINARY_IMM_OP DEST_REG SRC1 IMM",
"ASM_CODE : BINARY_IMM_OP DEST_REG IMM",
"ASM_CODE : SHIFT_OP DEST_REG SRC1 Y_INT",
"ASM_CODE : BINARY_OP_NOI DEST_REG SRC1 SRC2",
"ASM_CODE : BINARY_OP_NOI DEST_REG SRC1 IMM",
"ASM_CODE : BINARY_OP_NOI DEST_REG IMM",
"ASM_CODE : DIV_POP DEST_REG SRC1",
"ASM_CODE : DIV_POP DEST_REG SRC1 SRC2",
"ASM_CODE : DIV_POP DEST_REG SRC1 IMM",
"ASM_CODE : MUL_POP DEST_REG SRC1 SRC2",
"ASM_CODE : MUL_POP DEST_REG SRC1 IMM",
"ASM_CODE : MULT_OP SRC1 SRC2",
"ASM_CODE : Y_ROR_POP DEST_REG SRC1 SRC2",
"ASM_CODE : Y_ROL_POP DEST_REG SRC1 SRC2",
"ASM_CODE : Y_ROR_POP DEST_REG SRC1 IMM",
"ASM_CODE : Y_ROL_POP DEST_REG SRC1 IMM",
"ASM_CODE : SET_LE_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_LE_POP DEST_REG SRC1 IMM",
"ASM_CODE : SET_GT_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_GT_POP DEST_REG SRC1 IMM",
"ASM_CODE : SET_GE_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_GE_POP DEST_REG SRC1 IMM",
"ASM_CODE : SET_EQ_POP DEST_REG SRC1 SRC2",
"ASM_CODE : SET_EQ_POP DEST_REG SRC1 IMM",
"ASM_CODE : NULLARY_BR_OP LABEL",
"ASM_CODE : UNARY_BR_OP SRC1 LABEL",
"ASM_CODE : UNARY_BR_POP SRC1 LABEL",
"ASM_CODE : BINARY_BR_OP SRC1 SRC2 LABEL",
"ASM_CODE : BINARY_BR_OP SRC1 IMM LABEL",
"ASM_CODE : BR_GT_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_GT_POP SRC1 IMM LABEL",
"ASM_CODE : BR_GE_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_GE_POP SRC1 IMM LABEL",
"ASM_CODE : BR_LT_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_LT_POP SRC1 IMM LABEL",
"ASM_CODE : BR_LE_POP SRC1 SRC2 LABEL",
"ASM_CODE : BR_LE_POP SRC1 IMM LABEL",
"ASM_CODE : J_OPS LABEL",
"ASM_CODE : J_OPS SRC1",
"ASM_CODE : J_OPS DEST SRC1",
"ASM_CODE : B_OP LABEL",
"ASM_CODE : MOVE_COP_OP COP_REG COP_REG",
"ASM_CODE : MOV_FROM_HILO_OP REG",
"ASM_CODE : MOV_TO_HILO_OP REG",
"ASM_CODE : MOV_COP_OP REG COP_REG",
"ASM_CODE : CTL_COP_OP COP_REG COP_REG",
"ASM_CODE : FP_ABS_OP F_DEST F_SRC1",
"ASM_CODE : FP_BINARY_OP F_DEST F_SRC1 F_SRC2",
"ASM_CODE : FP_CONVERT_OP F_DEST F_SRC2",
"ASM_CODE : FP_NEG_OP F_DEST F_SRC2",
"ASM_CODE : FP_CMP_OP F_SRC1 F_SRC2",
"LOAD_OP : Y_LB_OP",
"LOAD_OP : Y_LBU_OP",
"LOAD_OP : Y_LH_OP",
"LOAD_OP : Y_LHU_OP",
"LOAD_OP : Y_LW_OP",
"LOAD_OP : Y_LWL_OP",
"LOAD_OP : Y_LWR_OP",
"LOAD_OP : Y_LD_POP",
"LOAD_COP : Y_LWC0_OP",
"LOAD_COP : Y_LWC2_OP",
"LOAD_COP : Y_LWC3_OP",
"LOAD_IMM_OP : Y_LUI_OP",
"ULOADH_POP : Y_ULH_POP",
"ULOADH_POP : Y_ULHU_POP",
"LOADF_OP : Y_LWC1_OP",
"LOADF_OP : Y_L_S_POP",
"LOADF_OP : Y_L_D_POP",
"STORE_OP : Y_SB_OP",
"STORE_OP : Y_SH_OP",
"STORE_OP : Y_SW_OP",
"STORE_OP : Y_SWL_OP",
"STORE_OP : Y_SWR_OP",
"STORE_OP : Y_SD_POP",
"STORE_COP : Y_SWC0_OP",
"STORE_COP : Y_SWC2_OP",
"STORE_COP : Y_SWC3_OP",
"STOREF_OP : Y_SWC1_OP",
"STOREF_OP : Y_S_S_POP",
"STOREF_OP : Y_S_D_POP",
"SYS_OP : Y_RFE_OP",
"SYS_OP : Y_SYSCALL_OP",
"BINARY_OP_I : Y_ADD_OP",
"BINARY_OP_I : Y_ADDU_OP",
"BINARY_OP_I : Y_AND_OP",
"BINARY_OP_I : Y_XOR_OP",
"BINARY_OP_I : Y_OR_OP",
"BINARY_OP_I : Y_SLT_OP",
"BINARY_OP_I : Y_SLTU_OP",
"BINARY_OPR_I : Y_SLLV_OP",
"BINARY_OPR_I : Y_SRAV_OP",
"BINARY_OPR_I : Y_SRLV_OP",
"BINARY_IMM_OP : Y_ADDI_OP",
"BINARY_IMM_OP : Y_ADDIU_OP",
"BINARY_IMM_OP : Y_ANDI_OP",
"BINARY_IMM_OP : Y_ORI_OP",
"BINARY_IMM_OP : Y_XORI_OP",
"BINARY_IMM_OP : Y_SLTI_OP",
"BINARY_IMM_OP : Y_SLTIU_OP",
"SHIFT_OP : Y_SLL_OP",
"SHIFT_OP : Y_SRA_OP",
"SHIFT_OP : Y_SRL_OP",
"BINARY_OP_NOI : Y_NOR_OP",
"BINARY_OP_NOI : Y_SUB_OP",
"BINARY_OP_NOI : Y_SUBU_OP",
"DIV_POP : Y_DIV_OP",
"DIV_POP : Y_DIVU_OP",
"DIV_POP : Y_REM_POP",
"DIV_POP : Y_REMU_POP",
"MUL_POP : Y_MUL_POP",
"MUL_POP : Y_MULO_POP",
"MUL_POP : Y_MULOU_POP",
"SET_LE_POP : Y_SLE_POP",
"SET_LE_POP : Y_SLEU_POP",
"SET_GT_POP : Y_SGT_POP",
"SET_GT_POP : Y_SGTU_POP",
"SET_GE_POP : Y_SGE_POP",
"SET_GE_POP : Y_SGEU_POP",
"SET_EQ_POP : Y_SEQ_POP",
"SET_EQ_POP : Y_SNE_POP",
"MULT_OP : Y_MULT_OP",
"MULT_OP : Y_MULTU_OP",
"NULLARY_BR_OP : Y_BC0T_OP",
"NULLARY_BR_OP : Y_BC1T_OP",
"NULLARY_BR_OP : Y_BC2T_OP",
"NULLARY_BR_OP : Y_BC3T_OP",
"NULLARY_BR_OP : Y_BC0F_OP",
"NULLARY_BR_OP : Y_BC1F_OP",
"NULLARY_BR_OP : Y_BC2F_OP",
"NULLARY_BR_OP : Y_BC3F_OP",
"UNARY_BR_OP : Y_BGEZ_OP",
"UNARY_BR_OP : Y_BGEZAL_OP",
"UNARY_BR_OP : Y_BGTZ_OP",
"UNARY_BR_OP : Y_BLEZ_OP",
"UNARY_BR_OP : Y_BLTZ_OP",
"UNARY_BR_OP : Y_BLTZAL_OP",
"UNARY_BR_POP : Y_BEQZ_POP",
"UNARY_BR_POP : Y_BNEZ_POP",
"BINARY_BR_OP : Y_BEQ_OP",
"BINARY_BR_OP : Y_BNE_OP",
"BR_GT_POP : Y_BGT_POP",
"BR_GT_POP : Y_BGTU_POP",
"BR_GE_POP : Y_BGE_POP",
"BR_GE_POP : Y_BGEU_POP",
"BR_LT_POP : Y_BLT_POP",
"BR_LT_POP : Y_BLTU_POP",
"BR_LE_POP : Y_BLE_POP",
"BR_LE_POP : Y_BLEU_POP",
"J_OPS : Y_J_OP",
"J_OPS : Y_JR_OP",
"J_OPS : Y_JAL_OP",
"J_OPS : Y_JALR_OP",
"B_OP : Y_B_POP",
"B_OP : Y_BAL_POP",
"MOVE_COP_OP : Y_MOV_S_OP",
"MOVE_COP_OP : Y_MOV_D_OP",
"MOV_FROM_HILO_OP : Y_MFHI_OP",
"MOV_FROM_HILO_OP : Y_MFLO_OP",
"MOV_TO_HILO_OP : Y_MTHI_OP",
"MOV_TO_HILO_OP : Y_MTLO_OP",
"MOV_COP_OP : Y_MFC0_OP",
"MOV_COP_OP : Y_MFC1_OP",
"MOV_COP_OP : Y_MFC1_D_POP",
"MOV_COP_OP : Y_MFC2_OP",
"MOV_COP_OP : Y_MFC3_OP",
"MOV_COP_OP : Y_MTC0_OP",
"MOV_COP_OP : Y_MTC1_OP",
"MOV_COP_OP : Y_MTC1_D_POP",
"MOV_COP_OP : Y_MTC2_OP",
"MOV_COP_OP : Y_MTC3_OP",
"CTL_COP_OP : Y_CFC0_OP",
"CTL_COP_OP : Y_CFC1_OP",
"CTL_COP_OP : Y_CFC2_OP",
"CTL_COP_OP : Y_CFC3_OP",
"CTL_COP_OP : Y_CTC0_OP",
"CTL_COP_OP : Y_CTC1_OP",
"CTL_COP_OP : Y_CTC2_OP",
"CTL_COP_OP : Y_CTC3_OP",
"FP_ABS_OP : Y_ABS_S_OP",
"FP_ABS_OP : Y_ABS_D_OP",
"FP_BINARY_OP : Y_ADD_S_OP",
"FP_BINARY_OP : Y_ADD_D_OP",
"FP_BINARY_OP : Y_DIV_S_OP",
"FP_BINARY_OP : Y_DIV_D_OP",
"FP_BINARY_OP : Y_MUL_S_OP",
"FP_BINARY_OP : Y_MUL_D_OP",
"FP_BINARY_OP : Y_SUB_S_OP",
"FP_BINARY_OP : Y_SUB_D_OP",
"FP_CONVERT_OP : Y_CVT_D_S_OP",
"FP_CONVERT_OP : Y_CVT_D_W_OP",
"FP_CONVERT_OP : Y_CVT_S_D_OP",
"FP_CONVERT_OP : Y_CVT_S_W_OP",
"FP_CONVERT_OP : Y_CVT_W_D_OP",
"FP_CONVERT_OP : Y_CVT_W_S_OP",
"FP_NEG_OP : Y_NEG_S_OP",
"FP_NEG_OP : Y_NEG_D_OP",
"FP_CMP_OP : Y_C_F_S_OP",
"FP_CMP_OP : Y_C_UN_S_OP",
"FP_CMP_OP : Y_C_EQ_S_OP",
"FP_CMP_OP : Y_C_UEQ_S_OP",
"FP_CMP_OP : Y_C_OLE_S_OP",
"FP_CMP_OP : Y_C_ULE_S_OP",
"FP_CMP_OP : Y_C_SF_S_OP",
"FP_CMP_OP : Y_C_NGLE_S_OP",
"FP_CMP_OP : Y_C_SEQ_S_OP",
"FP_CMP_OP : Y_C_NGL_S_OP",
"FP_CMP_OP : Y_C_LT_S_OP",
"FP_CMP_OP : Y_C_NGE_S_OP",
"FP_CMP_OP : Y_C_LE_S_OP",
"FP_CMP_OP : Y_C_NGT_S_OP",
"FP_CMP_OP : Y_C_F_D_OP",
"FP_CMP_OP : Y_C_UN_D_OP",
"FP_CMP_OP : Y_C_EQ_D_OP",
"FP_CMP_OP : Y_C_UEQ_D_OP",
"FP_CMP_OP : Y_C_OLE_D_OP",
"FP_CMP_OP : Y_C_ULE_D_OP",
"FP_CMP_OP : Y_C_SF_D_OP",
"FP_CMP_OP : Y_C_NGLE_D_OP",
"FP_CMP_OP : Y_C_SEQ_D_OP",
"FP_CMP_OP : Y_C_NGL_D_OP",
"FP_CMP_OP : Y_C_LT_D_OP",
"FP_CMP_OP : Y_C_NGE_D_OP",
"FP_CMP_OP : Y_C_LE_D_OP",
"FP_CMP_OP : Y_C_NGT_D_OP",
"ASM_DIRECTIVE : Y_ALIAS_DIR Y_REG Y_REG",
"ASM_DIRECTIVE : Y_ALIGN_DIR EXPR",
"$$2 :",
"ASM_DIRECTIVE : Y_ASCII_DIR $$2 STR_LST",
"$$3 :",
"ASM_DIRECTIVE : Y_ASCIIZ_DIR $$3 STR_LST",
"ASM_DIRECTIVE : Y_ASM0_DIR",
"ASM_DIRECTIVE : Y_BGNB_DIR Y_INT",
"$$4 :",
"ASM_DIRECTIVE : Y_BYTE_DIR $$4 EXPR_LST",
"ASM_DIRECTIVE : Y_COMM_DIR Y_ID EXPR",
"ASM_DIRECTIVE : Y_DATA_DIR",
"ASM_DIRECTIVE : Y_K_DATA_DIR",
"$$5 :",
"ASM_DIRECTIVE : Y_DOUBLE_DIR $$5 FP_EXPR_LST",
"ASM_DIRECTIVE : Y_END_DIR OPT_ID",
"ASM_DIRECTIVE : Y_ENDB_DIR Y_INT",
"ASM_DIRECTIVE : Y_ENDR_DIR",
"ASM_DIRECTIVE : Y_ENT_DIR Y_ID",
"ASM_DIRECTIVE : Y_ENT_DIR Y_ID Y_INT",
"ASM_DIRECTIVE : Y_EXTERN_DIR Y_ID EXPR",
"ASM_DIRECTIVE : Y_ERR_DIR",
"ASM_DIRECTIVE : Y_FILE_DIR Y_INT Y_STR",
"$$6 :",
"ASM_DIRECTIVE : Y_FLOAT_DIR $$6 FP_EXPR_LST",
"ASM_DIRECTIVE : Y_FMASK_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_FRAME_DIR REGISTER Y_INT REGISTER",
"ASM_DIRECTIVE : Y_GLOBAL_DIR Y_ID",
"$$7 :",
"ASM_DIRECTIVE : Y_HALF_DIR $$7 EXPR_LST",
"ASM_DIRECTIVE : Y_LABEL_DIR Y_ID",
"ASM_DIRECTIVE : Y_LCOMM_DIR Y_ID EXPR",
"ASM_DIRECTIVE : Y_LIVEREG_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_LOC_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_MASK_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_NOALIAS_DIR Y_REG Y_REG",
"ASM_DIRECTIVE : Y_OPTIONS_DIR Y_ID",
"ASM_DIRECTIVE : Y_REPEAT_DIR EXPR",
"ASM_DIRECTIVE : Y_RDATA_DIR",
"ASM_DIRECTIVE : Y_SDATA_DIR",
"ASM_DIRECTIVE : Y_SET_DIR Y_ID",
"ASM_DIRECTIVE : Y_SPACE_DIR EXPR",
"ASM_DIRECTIVE : Y_STRUCT_DIR EXPR",
"ASM_DIRECTIVE : Y_TEXT_DIR",
"ASM_DIRECTIVE : Y_K_TEXT_DIR",
"ASM_DIRECTIVE : Y_VERSTAMP_DIR Y_INT Y_INT",
"ASM_DIRECTIVE : Y_VREG_DIR REGISTER Y_INT Y_INT",
"$$8 :",
"ASM_DIRECTIVE : Y_WORD_DIR $$8 EXPR_LST",
"ADDRESS : '(' REGISTER ')'",
"ADDRESS : ABS_ADDR",
"ADDRESS : ABS_ADDR '(' REGISTER ')'",
"ADDRESS : Y_ID",
"ADDRESS : Y_ID '(' REGISTER ')'",
"ADDRESS : Y_ID '+' ABS_ADDR",
"ADDRESS : ABS_ADDR '+' Y_ID",
"ADDRESS : Y_ID '-' ABS_ADDR",
"ADDRESS : Y_ID '+' ABS_ADDR '(' REGISTER ')'",
"ADDRESS : Y_ID '-' ABS_ADDR '(' REGISTER ')'",
"IMM : ABS_ADDR",
"IMM : Y_ID",
"IMM : Y_ID '+' ABS_ADDR",
"IMM : Y_ID '-' ABS_ADDR",
"ABS_ADDR : Y_INT",
"DEST_REG : REGISTER",
"SRC1 : REGISTER",
"SRC2 : REGISTER",
"DEST : REGISTER",
"REG : REGISTER",
"SOURCE : REGISTER",
"REGISTER : Y_REG",
"F_DEST : FP_REGISTER",
"F_SRC1 : FP_REGISTER",
"F_SRC2 : FP_REGISTER",
"FP_REGISTER : Y_FP_REG",
"COP_REG : Y_REG",
"COP_REG : Y_FP_REG",
"LABEL : Y_ID",
"STR_LST : STR_LST Y_STR",
"STR_LST : Y_STR",
"EXPR : Y_INT",
"EXPR : Y_ID",
"EXPR_LST : EXPR_LST EXPR",
"EXPR_LST : EXPR",
"EXPR_LST : EXPR ':' Y_INT",
"FP_EXPR_LST : FP_EXPR_LST Y_FP",
"FP_EXPR_LST : Y_FP",
"OPT_ID : Y_ID",
"OPT_ID :",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1770 "parser.y"

/* Maintain and update the address of labels for the current line. */

void
fix_current_label_address (new_addr)
     mem_addr new_addr;
{
  label_list *l;

  for (l = this_line_labels; l != NULL; l = l->tail)
    l->head->addr = new_addr;
  clear_labels ();
}


static label_list *
cons_label (head, tail)
     label *head;
     label_list *tail;
{
  label_list *c = (label_list *) malloc (sizeof (label_list));

  c->head = head;
  c->tail = tail;
  return (c);
}


static void
clear_labels ()
{
  label_list *n;

  for ( ; this_line_labels != NULL; this_line_labels = n)
    {
      n = this_line_labels->tail;
      free (this_line_labels);
    }
}


/* Operations on op codes. */

int
op_to_imm_op (opcode)
     int opcode;
{
  switch (opcode)
    {
    case Y_ADD_OP: return (Y_ADDI_OP);
    case Y_ADDU_OP: return (Y_ADDIU_OP);
    case Y_AND_OP: return (Y_ANDI_OP);
    case Y_OR_OP: return (Y_ORI_OP);
    case Y_XOR_OP: return (Y_XORI_OP);
    case Y_SLT_OP: return (Y_SLTI_OP);
    case Y_SLTU_OP: return (Y_SLTIU_OP);
    case Y_SLLV_OP: return (Y_SLL_OP);
    case Y_SRAV_OP: return (Y_SRA_OP);
    case Y_SRLV_OP: return (Y_SRL_OP);
    default: fatal_error ("Can't convert op to immediate op");
      /*NOTREACHED*/
    }
}


int
imm_op_to_op (opcode)
     int opcode;
{
  switch (opcode)
    {
    case Y_ADDI_OP: return (Y_ADD_OP);
    case Y_ADDIU_OP: return (Y_ADDU_OP);
    case Y_ANDI_OP: return (Y_AND_OP);
    case Y_ORI_OP: return (Y_OR_OP);
    case Y_XORI_OP: return (Y_XOR_OP);
    case Y_SLTI_OP: return (Y_SLT_OP);
    case Y_SLTIU_OP: return (Y_SLTU_OP);
    case Y_J_OP: return (Y_JR_OP);
    case Y_LUI_OP: return (Y_ADDU_OP);
    case Y_SLL_OP: return (Y_SLLV_OP);
    case Y_SRA_OP: return (Y_SRAV_OP);
    case Y_SRL_OP: return (Y_SRLV_OP);
    default: fatal_error ("Can't convert immediate op to op");
      /*NOTREACHED*/
    }
}


static void
nop_inst ()
{
  r_type_inst (Y_OR_OP, 0, 0, 0);
}


static void
trap_inst ()
{
  r_type_inst (Y_BREAK_OP, 0, 0, 0);
}


imm_expr *
branch_offset (n_inst)
     int n_inst;
{
  return (const_imm_expr (n_inst << 2)); /* Later shifted right 2 places */
}


static void
div_inst (op, rd, rs, rt, const_divisor)
     int op, rd, rs, rt, const_divisor;
{
  if (rd != 0 && !const_divisor)
    {
      i_type_inst (Y_BNE_OP, 0, rt, branch_offset (2));
      trap_inst ();
    }
  if (op == Y_DIV_OP || op == Y_REM_POP)
    r_type_inst (Y_DIV_OP, 0, rs, rt);
  else
    r_type_inst (Y_DIVU_OP, 0, rs, rt);
  if (rd != 0)
    {
      if (op == Y_DIV_OP || op == Y_DIVU_OP)
	r_type_inst (Y_MFLO_OP, rd, 0, 0);
      else
	r_type_inst (Y_MFHI_OP, rd, 0, 0);
    }
}


static void
mult_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
{
  if (op == Y_MULOU_POP)
    r_type_inst (Y_MULTU_OP, 0, rs, rt);
  else
    r_type_inst (Y_MULT_OP, 0, rs, rt);
  if (op != Y_MUL_POP && rd != 0)
    {
      r_type_inst (Y_MFHI_OP, 1, 0, 0);	/* Use $at */
      i_type_inst (Y_BEQ_OP, 0, 1, branch_offset (2));
      trap_inst ();
    }
  if (rd != 0)
    r_type_inst (Y_MFLO_OP, rd, 0, 0);
}


static void
set_le_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
{
  i_type_inst (Y_BNE_OP, rs, rt, branch_offset (3));
  i_type_inst (Y_ORI_OP, rd, 0, const_imm_expr (1));
  i_type_inst (Y_BEQ_OP, 0, 0, branch_offset (2));
  r_type_inst ((op == Y_SLE_POP ? Y_SLT_OP : Y_SLTU_OP), rd, rs, rt);
}


static void
set_gt_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
{
  r_type_inst (op == Y_SGT_POP ? Y_SLT_OP : Y_SLTU_OP, rd, rt, rs);
}


static void
set_ge_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
{
  i_type_inst (Y_BNE_OP, rs, rt, branch_offset (3));
  i_type_inst (Y_ORI_OP, rd, 0, const_imm_expr (1));
  i_type_inst (Y_BEQ_OP, 0, 0, branch_offset (2));
  r_type_inst (op == Y_SGE_POP ? Y_SLT_OP : Y_SLTU_OP, rd, rt, rs);
}


static void
set_eq_inst (op, rd, rs, rt)
     int op, rd, rs, rt;
{
  imm_expr *if_eq, *if_neq;

  if (op == Y_SEQ_POP)
    if_eq = const_imm_expr (1), if_neq = const_imm_expr (0);
  else
    if_eq = const_imm_expr (0), if_neq = const_imm_expr (1);

  i_type_inst (Y_BEQ_OP, rs, rt, branch_offset (3));
  /* RD <- 0 (if not equal) */
  i_type_inst (Y_ORI_OP, rd, 0, if_neq);
  i_type_inst (Y_BEQ_OP, 0, 0, branch_offset (2)); /* Branch always */
  /* RD <- 1 */
  i_type_inst (Y_ORI_OP, rd, 0, if_eq);
}


/* Store the value either as a datum or instruction. */

static void
store_word_data (value)
     int value;
{
  if (data_dir)
    store_word (value);
  else if (text_dir)
    store_instruction (inst_decode (value));
}



void
yyerror (s)
     char *s;
{
  extern int line_no;
  extern char *input_file_name;

  error ("spim: (parser) %s on line %d of file %s\n",
	 s, line_no, input_file_name);
  print_erroneous_line ();
}
#line 1524 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 394 "parser.y"
{scanner_start_line ();}
break;
case 3:
#line 397 "parser.y"
{
			   this_line_labels =
			     cons_label (record_label
					 (yyvsp[-1], (text_dir ? current_text_pc ()
					       : current_data_pc ())),
					 this_line_labels);
			 }
break;
case 4:
#line 405 "parser.y"
{}
break;
case 5:
#line 410 "parser.y"
{
		  clear_labels ();
		  return (1);
		}
break;
case 6:
#line 416 "parser.y"
{
		  clear_labels ();
		  return (1);
		}
break;
case 7:
#line 422 "parser.y"
{
		  return (1);
		}
break;
case 8:
#line 427 "parser.y"
{
		  clear_labels ();
		  return (0);
		}
break;
case 9:
#line 436 "parser.y"
{
		  i_type_inst (yyvsp[-2] == Y_LD_POP ? Y_LW_OP : yyvsp[-2],
			       yyvsp[-1], addr_expr_reg (yyvsp[0]), addr_expr_imm (yyvsp[0]));
		  if (yyvsp[-2] == Y_LD_POP)
		    i_type_inst (Y_LW_OP, yyvsp[-1] + 1, addr_expr_reg (yyvsp[0]),
				 incr_expr_offset (addr_expr_imm (yyvsp[0]), 4));
		  free (yyvsp[0]);
		}
break;
case 10:
#line 446 "parser.y"
{
		  i_type_inst (yyvsp[-2], yyvsp[-1], addr_expr_reg (yyvsp[0]), addr_expr_imm (yyvsp[0]));
		  free (yyvsp[0]);
		}
break;
case 11:
#line 452 "parser.y"
{
		  i_type_inst (yyvsp[-2], yyvsp[-1], 0, yyvsp[0]);
		}
break;
case 12:
#line 458 "parser.y"
{
		  if (addr_expr_reg (yyvsp[0]))
		    i_type_inst (Y_ADDI_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
				 addr_expr_imm (yyvsp[0]));
		  else
		    i_type_inst (Y_LUI_OP, yyvsp[-1], 0, addr_expr_imm (yyvsp[0]));
		  free (yyvsp[0]);
		}
break;
case 13:
#line 469 "parser.y"
{
		  i_type_inst (Y_ORI_OP, yyvsp[-1], 0, yyvsp[0]);
		}
break;
case 14:
#line 475 "parser.y"
{
		  int *x = (int *) yyvsp[0];

		  i_type_inst (Y_ORI_OP, 1, 0, const_imm_expr (*x));
		  r_type_inst (Y_MTC1_OP, yyvsp[-1], 0, 1);
		  i_type_inst (Y_ORI_OP, 1, 0, const_imm_expr (*(x+1)));
		  r_type_inst (Y_MTC1_OP, yyvsp[-1] + 1, 0, 1);
		}
break;
case 15:
#line 486 "parser.y"
{
		  float x = * ((double *) yyvsp[0]);
		  int *y = (int *) &x;

		  i_type_inst (Y_ORI_OP, 1, 0, const_imm_expr (*y));
		  r_type_inst (Y_MTC1_OP, yyvsp[-1], 0, 1);
		}
break;
case 16:
#line 496 "parser.y"
{
#ifdef BIGENDIAN
		  i_type_inst (Y_LWL_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
		  i_type_inst (Y_LWR_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 3));
#else
		  i_type_inst (Y_LWL_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 3));
		  i_type_inst (Y_LWR_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
#endif
		  free (yyvsp[0]);
		}
break;
case 17:
#line 513 "parser.y"
{
#ifdef BIGENDIAN
		  i_type_inst ((yyvsp[-2] == Y_ULH_POP ? Y_LB_OP : Y_LBU_OP),
			       yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
		  i_type_inst (Y_LBU_OP, 1, addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 1));
#else
		  i_type_inst ((yyvsp[-2] == Y_ULH_POP ? Y_LB_OP : Y_LBU_OP),
			       yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 1));
		  i_type_inst (Y_LBU_OP, 1, addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
#endif
		  r_sh_type_inst (Y_SLL_OP, yyvsp[-1], yyvsp[-1], 8);
		  r_type_inst (Y_OR_OP, yyvsp[-1], yyvsp[-1], 1);
		  free (yyvsp[0]);
		}
break;
case 18:
#line 534 "parser.y"
{
		  i_type_inst (Y_LWC1_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
		  if (yyvsp[-2] == Y_L_D_POP)
		    i_type_inst (Y_LWC1_OP, yyvsp[-1] + 1, addr_expr_reg (yyvsp[0]),
				 incr_expr_offset (addr_expr_imm (yyvsp[0]), 4));
		  free (yyvsp[0]);
		}
break;
case 19:
#line 545 "parser.y"
{
		  i_type_inst (yyvsp[-2] == Y_SD_POP ? Y_SW_OP : yyvsp[-2],
			       yyvsp[-1], addr_expr_reg (yyvsp[0]), addr_expr_imm (yyvsp[0]));
		  if (yyvsp[-2] == Y_SD_POP)
		    i_type_inst (Y_SW_OP, yyvsp[-1] + 1, addr_expr_reg (yyvsp[0]),
				 incr_expr_offset (addr_expr_imm (yyvsp[0]), 4));
		  free (yyvsp[0]);
		}
break;
case 20:
#line 556 "parser.y"
{
		  i_type_inst (yyvsp[-2], yyvsp[-1], addr_expr_reg (yyvsp[0]), addr_expr_imm (yyvsp[0]));
		  free (yyvsp[0]);
		}
break;
case 21:
#line 563 "parser.y"
{
#ifdef BIGENDIAN
		  i_type_inst (Y_SWL_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
		  i_type_inst (Y_SWR_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 3));
#else
		  i_type_inst (Y_SWL_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 3));
		  i_type_inst (Y_SWR_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
#endif
		  free (yyvsp[0]);
		}
break;
case 22:
#line 580 "parser.y"
{
		  i_type_inst (Y_SB_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
		  r_sh_type_inst (Y_SRL_OP, 1, yyvsp[-1], 8);
		  i_type_inst (Y_SB_OP, 1, addr_expr_reg (yyvsp[0]),
			       incr_expr_offset (addr_expr_imm (yyvsp[0]), 1));
		  free (yyvsp[0]);
		}
break;
case 23:
#line 591 "parser.y"
{
		  i_type_inst (Y_SWC1_OP, yyvsp[-1], addr_expr_reg (yyvsp[0]),
			       addr_expr_imm (yyvsp[0]));
		  if (yyvsp[-2] == Y_S_D_POP)
		    i_type_inst (Y_SWC1_OP, yyvsp[-1] + 1, addr_expr_reg (yyvsp[0]),
				 incr_expr_offset (addr_expr_imm (yyvsp[0]), 4));
		  free (yyvsp[0]);
		}
break;
case 24:
#line 602 "parser.y"
{
		  r_type_inst (yyvsp[0], 0, 0, 0);
		}
break;
case 25:
#line 608 "parser.y"
{
		  if (yyvsp[0] == 1)
		    yyerror ("Breakpoint 1 is reserved for debugger");
		  r_type_inst (yyvsp[-1], yyvsp[0], 0, 0);
		}
break;
case 26:
#line 616 "parser.y"
{
		  nop_inst ();
		}
break;
case 27:
#line 622 "parser.y"
{
		  if (yyvsp[-1] != yyvsp[0])
		    r_type_inst (Y_ADDU_OP, yyvsp[-1], 0, yyvsp[0]);

		  i_type_inst (Y_BGEZ_OP, 0, yyvsp[0], branch_offset (2));
		  r_type_inst (Y_SUB_OP, yyvsp[-1], 0, yyvsp[0]);
		}
break;
case 28:
#line 632 "parser.y"
{
		  r_type_inst (Y_SUB_OP, yyvsp[-1], 0, yyvsp[0]);
		}
break;
case 29:
#line 638 "parser.y"
{
		  r_type_inst (Y_SUBU_OP, yyvsp[-1], 0, yyvsp[0]);
		}
break;
case 30:
#line 644 "parser.y"
{
		  i_type_inst (Y_XORI_OP, yyvsp[-1], yyvsp[0], const_imm_expr (1));
		}
break;
case 31:
#line 650 "parser.y"
{
		  r_type_inst (Y_ADDU_OP, yyvsp[-1], 0, yyvsp[0]);
		}
break;
case 32:
#line 656 "parser.y"
{
		  r_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 33:
#line 662 "parser.y"
{
		  i_type_inst (op_to_imm_op (yyvsp[-3]), yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 34:
#line 668 "parser.y"
{
		  i_type_inst (op_to_imm_op (yyvsp[-2]), yyvsp[-1], yyvsp[-1], yyvsp[0]);
		}
break;
case 35:
#line 674 "parser.y"
{
		  r_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[0], yyvsp[-1]);
		}
break;
case 36:
#line 680 "parser.y"
{
		  i_type_inst (op_to_imm_op (yyvsp[-3]), yyvsp[-2], yyvsp[0], yyvsp[-1]);
		}
break;
case 37:
#line 686 "parser.y"
{
		  i_type_inst (op_to_imm_op (yyvsp[-2]), yyvsp[-1], yyvsp[0], yyvsp[-1]);
		}
break;
case 38:
#line 692 "parser.y"
{
		  i_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 39:
#line 698 "parser.y"
{
		  i_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[-1], yyvsp[0]);
		}
break;
case 40:
#line 704 "parser.y"
{
		  r_sh_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 41:
#line 710 "parser.y"
{
		  r_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 42:
#line 716 "parser.y"
{
		  if (bare_machine)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    {
		      if (!zero_imm (yyvsp[0]))
			i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		      r_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], (zero_imm (yyvsp[0]) ? 0 : 1));
		    }
		}
break;
case 43:
#line 729 "parser.y"
{
		  if (bare_machine)
		    yyerror ("Immediate form not allowed in bare machine");
		  else
		    {
		      if (!zero_imm (yyvsp[0]))
			i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		      r_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[-1], (zero_imm (yyvsp[0]) ? 0 : 1));
		    }
		}
break;
case 44:
#line 742 "parser.y"
{
		  /* The hardware divide operation (ignore 1st arg) */
		  if (yyvsp[-2] != Y_DIV_OP && yyvsp[-2] != Y_DIVU_OP)
		    yyerror ("Syntax error");
		  r_type_inst (yyvsp[-2], 0, yyvsp[-1], yyvsp[0]);
		}
break;
case 45:
#line 750 "parser.y"
{
		  /* Pseudo divide operations */
		  div_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0], 0);
		}
break;
case 46:
#line 756 "parser.y"
{
		  if (zero_imm (yyvsp[0]))
		    yyerror ("Divide by zero");
		  else
		    {
		      i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		      div_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], 1, 1);
		    }
		}
break;
case 47:
#line 768 "parser.y"
{
		  mult_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 48:
#line 773 "parser.y"
{
		  if (zero_imm (yyvsp[0]))
		    r_type_inst (Y_ORI_OP, yyvsp[-2], 0, 0);
		  else
		    {
		      i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		      mult_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], 1);
		    }
		}
break;
case 49:
#line 785 "parser.y"
{
		  r_type_inst (yyvsp[-2], 0, yyvsp[-1], yyvsp[0]);
		}
break;
case 50:
#line 791 "parser.y"
{
		  r_type_inst (Y_SUBU_OP, 1, 0, yyvsp[0]);
		  r_type_inst (Y_SLLV_OP, 1, 1, yyvsp[-1]);
		  r_type_inst (Y_SRLV_OP, yyvsp[-2], yyvsp[0], yyvsp[-1]);
		  r_type_inst (Y_OR_OP, yyvsp[-2], yyvsp[-2], 1);
		}
break;
case 51:
#line 800 "parser.y"
{
		  r_type_inst (Y_SUBU_OP, 1, 0, yyvsp[0]);
		  r_type_inst (Y_SRLV_OP, 1, 1, yyvsp[-1]);
		  r_type_inst (Y_SLLV_OP, yyvsp[-2], yyvsp[0], yyvsp[-1]);
		  r_type_inst (Y_OR_OP, yyvsp[-2], yyvsp[-2], 1);
		}
break;
case 52:
#line 809 "parser.y"
{
		  long dist = eval_imm_expr (yyvsp[0]);

		  r_sh_type_inst (Y_SLL_OP, 1, yyvsp[-1], -dist);
		  r_sh_type_inst (Y_SRL_OP, yyvsp[-2], yyvsp[-1], dist);
		  r_type_inst (Y_OR_OP, yyvsp[-2], yyvsp[-2], 1);
		}
break;
case 53:
#line 819 "parser.y"
{
		  long dist = eval_imm_expr (yyvsp[0]);

		  r_sh_type_inst (Y_SRL_OP, 1, yyvsp[-1], -dist);
		  r_sh_type_inst (Y_SLL_OP, yyvsp[-2], yyvsp[-1], dist);
		  r_type_inst (Y_OR_OP, yyvsp[-2], yyvsp[-2], 1);
		}
break;
case 54:
#line 830 "parser.y"
{
		  set_le_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 55:
#line 835 "parser.y"
{
		  if (!zero_imm (yyvsp[0]))
		    i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		  set_le_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], (zero_imm (yyvsp[0]) ? 0 : 1));
		}
break;
case 56:
#line 843 "parser.y"
{
		  set_gt_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 57:
#line 848 "parser.y"
{
		  if (!zero_imm (yyvsp[0]))
		    i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		  set_gt_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], (zero_imm (yyvsp[0]) ? 0 : 1));
		}
break;
case 58:
#line 857 "parser.y"
{
		  set_ge_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 59:
#line 862 "parser.y"
{
		  if (!zero_imm (yyvsp[0]))
		    i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		  set_ge_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], (zero_imm (yyvsp[0]) ? 0 : 1));
		}
break;
case 60:
#line 870 "parser.y"
{
		  set_eq_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 61:
#line 875 "parser.y"
{
		  if (!zero_imm (yyvsp[0]))
		    i_type_inst (Y_ORI_OP, 1, 0, yyvsp[0]); /* Use $at */
		  set_eq_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], (zero_imm (yyvsp[0]) ? 0 : 1));
		}
break;
case 62:
#line 883 "parser.y"
{
		  i_type_inst (yyvsp[-1], 0, 0, yyvsp[0]);
		}
break;
case 63:
#line 889 "parser.y"
{
		  i_type_inst (yyvsp[-2], 0, yyvsp[-1], yyvsp[0]);
		}
break;
case 64:
#line 895 "parser.y"
{
		  i_type_inst (yyvsp[-2] == Y_BEQZ_POP ? Y_BEQ_OP : Y_BNE_OP,
			       0, yyvsp[-1], yyvsp[0]);
		}
break;
case 65:
#line 902 "parser.y"
{
		  i_type_inst (yyvsp[-3], yyvsp[-1], yyvsp[-2], yyvsp[0]);
		}
break;
case 66:
#line 907 "parser.y"
{
		  if (bare_machine)
		    yyerror ("Immediate form not allowed on bare machine");
		  else
		    {
		      if (zero_imm (yyvsp[-1]))
			i_type_inst (yyvsp[-3], yyvsp[-2], (zero_imm (yyvsp[-1]) ? 0 : 1), yyvsp[0]);
		      else
			{
			  i_type_inst (Y_ORI_OP, 1, 0, yyvsp[-1]); /* Use $at */
			  i_type_inst (yyvsp[-3], yyvsp[-2], (zero_imm (yyvsp[-1]) ? 0 : 1), yyvsp[0]);
			}
		    }
		}
break;
case 67:
#line 924 "parser.y"
{
		  r_type_inst (yyvsp[-3] == Y_BGT_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-1], yyvsp[-2]); /* Use $at */
		  i_type_inst (Y_BNE_OP, 0, 1, yyvsp[0]);
		}
break;
case 68:
#line 931 "parser.y"
{
		  if (yyvsp[-3] == Y_BGT_POP)
		    {
		      /* Use $at */
		      i_type_inst (Y_SLTI_OP, 1, yyvsp[-2], incr_expr_offset (yyvsp[-1], 1));
		      i_type_inst (Y_BEQ_OP, 0, 1, yyvsp[0]);
		    }
		  else
		    {
		      /* Use $at */
		      /* Can't add 1 to immediate since 0xffffffff+1 = 0 < 1 */
		      i_type_inst (Y_ORI_OP, 1, 0, yyvsp[-1]);
		      i_type_inst (Y_BEQ_OP, yyvsp[-2], 1, branch_offset (3));
		      r_type_inst (Y_SLTU_OP, 1, yyvsp[-2], 1);
		      i_type_inst (Y_BEQ_OP, 0, 1, yyvsp[0]);
		    }
		}
break;
case 69:
#line 951 "parser.y"
{
		  r_type_inst (yyvsp[-3] == Y_BGE_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-2], yyvsp[-1]); /* Use $at */
		  i_type_inst (Y_BEQ_OP, 0, 1, yyvsp[0]);
		}
break;
case 70:
#line 958 "parser.y"
{
		  i_type_inst (yyvsp[-3] == Y_BGE_POP ? Y_SLTI_OP : Y_SLTIU_OP,
			       1, yyvsp[-2], yyvsp[-1]); /* Use $at */
		  i_type_inst (Y_BEQ_OP, 0, 1, yyvsp[0]);
		}
break;
case 71:
#line 966 "parser.y"
{
		  r_type_inst (yyvsp[-3] == Y_BLT_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-2], yyvsp[-1]); /* Use $at */
		  i_type_inst (Y_BNE_OP, 0, 1, yyvsp[0]);
		}
break;
case 72:
#line 973 "parser.y"
{
		  i_type_inst (yyvsp[-3] == Y_BLT_POP ? Y_SLTI_OP : Y_SLTIU_OP,
			       1, yyvsp[-2], yyvsp[-1]); /* Use $at */
		  i_type_inst (Y_BNE_OP, 0, 1, yyvsp[0]);
		}
break;
case 73:
#line 981 "parser.y"
{
		  r_type_inst (yyvsp[-3] == Y_BLE_POP ? Y_SLT_OP : Y_SLTU_OP,
			       1, yyvsp[-1], yyvsp[-2]); /* Use $at */
		  i_type_inst (Y_BEQ_OP, 0, 1, yyvsp[0]);
		}
break;
case 74:
#line 988 "parser.y"
{
		  if (yyvsp[-3] == Y_BLE_POP)
		    {
		      /* Use $at */
		      i_type_inst (Y_SLTI_OP, 1, yyvsp[-2], incr_expr_offset (yyvsp[-1], 1));
		      i_type_inst (Y_BNE_OP, 0, 1, yyvsp[0]);
		    }
		  else
		    {
		      /* Use $at */
		      /* Can't add 1 to immediate since 0xffffffff+1 = 0 < 1 */
		      i_type_inst (Y_ORI_OP, 1, 0, yyvsp[-1]);
		      i_type_inst (Y_BEQ_OP, yyvsp[-2], 1, copy_imm_expr (yyvsp[0]));
		      r_type_inst (Y_SLTU_OP, 1, yyvsp[-2], 1);
		      i_type_inst (Y_BNE_OP, 0, 1, yyvsp[0]);
		    }
		}
break;
case 75:
#line 1008 "parser.y"
{
		  if ((yyvsp[-1] == Y_J_OP) || (yyvsp[-1] == Y_JR_OP))
		    j_type_inst (Y_J_OP, yyvsp[0]);
		  else if ((yyvsp[-1] == Y_JAL_OP) || (yyvsp[-1] == Y_JALR_OP))
		    j_type_inst (Y_JAL_OP, yyvsp[0]);
		}
break;
case 76:
#line 1017 "parser.y"
{
		  if ((yyvsp[-1] == Y_J_OP) || (yyvsp[-1] == Y_JR_OP))
		    r_type_inst (Y_JR_OP, 0, yyvsp[0], 0);
		  else if ((yyvsp[-1] == Y_JAL_OP) || (yyvsp[-1] == Y_JALR_OP))
		    r_type_inst (Y_JALR_OP, 31, yyvsp[0], 0);
		}
break;
case 77:
#line 1026 "parser.y"
{
		  if ((yyvsp[-2] == Y_J_OP) || (yyvsp[-2] == Y_JR_OP))
		    r_type_inst (Y_JR_OP, 0, yyvsp[0], 0);
		  else if ((yyvsp[-2] == Y_JAL_OP) || (yyvsp[-2] == Y_JALR_OP))
		    r_type_inst (Y_JALR_OP, yyvsp[-1], yyvsp[0], 0);
		}
break;
case 78:
#line 1035 "parser.y"
{
		  i_type_inst ((yyvsp[-1] == Y_BAL_POP ? Y_BGEZAL_OP : Y_BGEZ_OP),
			       0, 0, yyvsp[0]);
		}
break;
case 79:
#line 1043 "parser.y"
{
		  r_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[0], 0);
		}
break;
case 80:
#line 1049 "parser.y"
{
		  r_type_inst (yyvsp[-1], yyvsp[0], 0, 0);
		}
break;
case 81:
#line 1055 "parser.y"
{
		  r_type_inst (yyvsp[-1], 0, yyvsp[0], 0);
		}
break;
case 82:
#line 1061 "parser.y"
{
		  if (yyvsp[-2] == Y_MFC1_D_POP)
		    {
		      r_type_inst (Y_MFC1_OP, yyvsp[0], 0, yyvsp[-1]);
		      r_type_inst (Y_MFC1_OP, yyvsp[0] + 1, 0, yyvsp[-1] + 1);
		    }
		  else if (yyvsp[-2] == Y_MTC1_D_POP)
		    {
		      r_type_inst (Y_MTC1_OP, yyvsp[0], 0, yyvsp[-1]);
		      r_type_inst (Y_MTC1_OP, yyvsp[0] + 1, 0, yyvsp[-1] + 1);
		    }
		  else
		    r_type_inst (yyvsp[-2], yyvsp[0], 0, yyvsp[-1]);
		}
break;
case 83:
#line 1078 "parser.y"
{
		  r_type_inst (yyvsp[-2], yyvsp[0], 0, yyvsp[-1]);
		}
break;
case 84:
#line 1084 "parser.y"
{
		  r_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[0], 0);
		}
break;
case 85:
#line 1090 "parser.y"
{
		  r_type_inst (yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 86:
#line 1096 "parser.y"
{
		  r_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[0], 0);
		}
break;
case 87:
#line 1102 "parser.y"
{
		  r_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[0], 0);
		}
break;
case 88:
#line 1108 "parser.y"
{
		  r_cond_type_inst (yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 263:
#line 1379 "parser.y"
{
		  align_data (yyvsp[0]);
		}
break;
case 264:
#line 1383 "parser.y"
{null_term = 0;}
break;
case 265:
#line 1384 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 266:
#line 1389 "parser.y"
{null_term = 1;}
break;
case 267:
#line 1390 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 270:
#line 1401 "parser.y"
{store_op = store_byte;}
break;
case 271:
#line 1402 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 272:
#line 1409 "parser.y"
{
		  align_data (2);
		  if (lookup_label (yyvsp[-1])->addr == 0)
		    record_label (yyvsp[-1],current_data_pc ());
		  increment_data_pc (yyvsp[0]);
		}
break;
case 273:
#line 1418 "parser.y"
{
		  user_kernel_data_segment (0);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 274:
#line 1425 "parser.y"
{
		  user_kernel_data_segment (1);
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 275:
#line 1431 "parser.y"
{store_op = store_double;}
break;
case 276:
#line 1432 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 282:
#line 1449 "parser.y"
{
		  extern_directive (yyvsp[-1], yyvsp[0]);
		}
break;
case 283:
#line 1455 "parser.y"
{
		  fatal_error ("File contains an .err directive");
		}
break;
case 285:
#line 1463 "parser.y"
{store_op = store_float;}
break;
case 286:
#line 1464 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 289:
#line 1476 "parser.y"
{
		  make_label_global (yyvsp[0]);
		}
break;
case 290:
#line 1481 "parser.y"
{store_op = store_half;}
break;
case 291:
#line 1482 "parser.y"
{
		  if (text_dir)
		    yyerror ("Can't put data in text segment");
		}
break;
case 292:
#line 1489 "parser.y"
{
		  record_label (yyvsp[-1], (text_dir ? current_text_pc ()
				     : current_data_pc ()));
		}
break;
case 293:
#line 1496 "parser.y"
{
		  lcomm_directive (yyvsp[-1], yyvsp[0]);
		}
break;
case 299:
#line 1514 "parser.y"
{
		  yyerror ("Warning: repeat directive ignored");
		}
break;
case 300:
#line 1520 "parser.y"
{
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 301:
#line 1527 "parser.y"
{
		  data_dir = 1; text_dir = 0;
		  enable_data_alignment ();
		}
break;
case 302:
#line 1534 "parser.y"
{
		  if (streq (yyvsp[0], "noat"))
		    noat_flag = 1;
		  else if (streq (yyvsp[0], "at"))
		    noat_flag = 0;
		}
break;
case 303:
#line 1543 "parser.y"
{
		  if (data_dir)
		    increment_data_pc (yyvsp[0]);
		  else if (text_dir)
		    increment_text_pc (yyvsp[0]);
		}
break;
case 304:
#line 1552 "parser.y"
{
		  yyerror ("Warning: struct directive ignored");
		}
break;
case 305:
#line 1558 "parser.y"
{
		  user_kernel_text_segment (0);
		  data_dir = 0; text_dir = 1;
		  enable_data_alignment ();
		}
break;
case 306:
#line 1566 "parser.y"
{
		  user_kernel_text_segment (1);
		  data_dir = 0; text_dir = 1;
		  enable_data_alignment ();
		}
break;
case 309:
#line 1578 "parser.y"
{store_op = store_word_data;}
break;
case 311:
#line 1585 "parser.y"
{
		  yyval = (int) make_addr_expr (0, NULL, yyvsp[-1]);
		}
break;
case 312:
#line 1590 "parser.y"
{
		  yyval = (int) make_addr_expr (yyvsp[0], NULL, 0);
		}
break;
case 313:
#line 1595 "parser.y"
{
		  yyval = (int) make_addr_expr (yyvsp[-3], NULL, yyvsp[-1]);
		}
break;
case 314:
#line 1600 "parser.y"
{
		  yyval = (int) make_addr_expr (0, yyvsp[0], 0);
		}
break;
case 315:
#line 1605 "parser.y"
{
		  yyval = (int) make_addr_expr (0, yyvsp[-3], yyvsp[-1]);
		}
break;
case 316:
#line 1610 "parser.y"
{
		  yyval = (int) make_addr_expr (yyvsp[0], yyvsp[-2], 0);
		}
break;
case 317:
#line 1615 "parser.y"
{
		  yyval = (int) make_addr_expr (yyvsp[-2], yyvsp[0], 0);
		}
break;
case 318:
#line 1620 "parser.y"
{
		  yyval = (int) make_addr_expr (- yyvsp[0], yyvsp[-2], 0);
		}
break;
case 319:
#line 1625 "parser.y"
{
		  yyval = (int) make_addr_expr (yyvsp[-3], yyvsp[-5], yyvsp[-1]);
		}
break;
case 320:
#line 1630 "parser.y"
{
		  yyval = (int) make_addr_expr (- yyvsp[-3], yyvsp[-5], yyvsp[-1]);
		}
break;
case 321:
#line 1637 "parser.y"
{
		  yyval = (int) make_imm_expr (yyvsp[0], NULL, 0);
		}
break;
case 322:
#line 1642 "parser.y"
{
		  yyval = (int) make_imm_expr (0, yyvsp[0], 0);
		}
break;
case 323:
#line 1647 "parser.y"
{
		  yyval = (int) make_imm_expr (yyvsp[0], yyvsp[-2], 0);
		}
break;
case 324:
#line 1652 "parser.y"
{
		  yyval = (int) make_imm_expr (- yyvsp[0], yyvsp[-2], 0);
		}
break;
case 332:
#line 1673 "parser.y"
{
		  if (yyvsp[0] < 0 || yyvsp[0] > 31)
		    yyerror ("Register number out of range");
		  if (yyvsp[0] == 1 && !bare_machine && !noat_flag)
		    yyerror ("Register 1 is reserved for assembler");
		  yyval = yyvsp[0];
		}
break;
case 336:
#line 1688 "parser.y"
{
		  if (yyvsp[0] < 0 || yyvsp[0] > 31)
		    yyerror ("FP register number out of range");
		  yyval = yyvsp[0];
		}
break;
case 339:
#line 1703 "parser.y"
{
		  yyval = (int) make_imm_expr (- current_text_pc (), yyvsp[0], 1);
		}
break;
case 340:
#line 1709 "parser.y"
{
		  store_string (yyvsp[0], y_str_length, null_term);
		}
break;
case 341:
#line 1713 "parser.y"
{
		  store_string (yyvsp[0], y_str_length, null_term);
		}
break;
case 343:
#line 1722 "parser.y"
{
		  label *l = lookup_label (yyvsp[0]);

		  if (l->addr == NULL)
		    {
		      record_data_uses_symbol (current_data_pc (), l);
		      yyval = 0;
		    }
		  else
		    yyval = l->addr;
		}
break;
case 344:
#line 1736 "parser.y"
{
		  store_op (yyvsp[0]);
		}
break;
case 345:
#line 1740 "parser.y"
{
		  store_op (yyvsp[0]);
		}
break;
case 346:
#line 1744 "parser.y"
{
		  int i;

		  for (i = 0; i < yyvsp[0]; i ++)
		    store_op (yyvsp[-2]);
		}
break;
case 347:
#line 1754 "parser.y"
{
		  store_op (yyvsp[0]);
		}
break;
case 348:
#line 1758 "parser.y"
{
		  store_op (yyvsp[0]);
		}
break;
case 350:
#line 1765 "parser.y"
{yyval = NULL;}
break;
#line 2761 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
